#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;

namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new PDF document being generated using Essential PDF.  At the end of the document generation, an option will be provided to view the generated PDF file. Please note that you need to have a PDF viewer installed in order to view the generated PDF file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//Setting the Cursor in Wait Mode.
			this.Cursor = Cursors.WaitCursor;

			//Create a new PDF Document. The pdfDoc object represents the PDF document.
			//This document has one page by default and additional pages have to be added.
			PDFDocument pdfDoc = new PDFDocument();
			pdfDoc.AutoCreatePages = true;

			//Adding a font that can be used to draw Text inside the PDF document.
			//Using the Predefined fonts to draw the text. 
			IPDFFont font = pdfDoc.Fonts.Add(FontBaseFamily.Courier);
			font.Size = 12;
			
			//IPDFGraphicState is used for setting properties of all drawing objects.
			IPDFGraphicState props = pdfDoc.CreateGraphicState();
			props.BreakBehavior = AutoBreakBehavior.MultiLineTextBreak;
			props.ForeColor = Color.Blue;
			//Insert Text into the pdf Document.
			System.IO.StreamReader myFile = new System.IO.StreamReader(@"..\..\Data\Book.txt", System.Text.Encoding.ASCII);
			string Book = myFile.ReadToEnd();

			//Measure string and set the width.
			SizeF sizeOfText = pdfDoc.Graphics.MeasureString(Book, font, (float)(pdfDoc.LastPage.DrawingWidth), props);
			
			RectangleF Rect = new RectangleF(new PointF(0, 0), sizeOfText);

			//Write the string[DrawMultiText - Draws string text, that is enclosed into specified boundarires]
			pdfDoc.LastPage.Graphics.DrawMultiText(Rect, Book, font, props);

			//Save the PDF Document to disk.
			pdfDoc.Save("Sample.pdf");

			//Setting the Cursor in Arrow mode.
			this.Cursor = Cursors.Arrow;

			
			//Message box confirmation to view the created PDF document.
			if (MessageBox.Show ("Do you want to view the PDF file?", "PDF File Created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the PDF file using the default Application.[Acrobat Reader]
				System.Diagnostics.Process.Start("Sample.pdf");
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
		}

	}
}
